#include <linux/module.h>

MODULE_LICENSE("GPL");
MODULE_AUTHOR("Pablo Virolainen <pablo.virolainen@nomovok.com>");

/* Copy-paste from arch/x86/vdso/vdso32-setup.c */

enum {
        VDSO_DISABLED = 0,
        VDSO_ENABLED = 1,
        VDSO_COMPAT = 2,
};

#ifndef CONFIG_X86_64
#error "Don't even try to compile me.. use /proc/sys/vm/vdso_enabled instread"
#endif

/* You need to get the next magic value from you kernel System.map.
 * grep sysctl_vsyscall32 <your System.map>.
 * The current value is from ubuntu something.
 */

#ifdef VDSO32_ADDR
unsigned int* vdso32_enabled=(unsigned int*) VDSO32_ADDR ;
unsigned int old_vdso32_enabled;
#else 
#error "You did just try to build the module without grepping?"
#error "grep sysctl_vsyscall32 /boot/System.map-`uname -r` and put the magic value to vdso32_enabled (just replace ffffffff806f0984 with your)"
#endif

static int __init vdso_disable_init(void)
{
	printk(KERN_INFO "Good Morning. Channging vdso32 from %i to %i\n",
	       *vdso32_enabled,VDSO_DISABLED);

	old_vdso32_enabled = *vdso32_enabled;
	*vdso32_enabled = VDSO_DISABLED;
	return 0;
}

static void __exit vdso_disable_exit(void)
{
	printk(KERN_INFO "Goodbye. Restoring old vdso value (%i)\n",
	       old_vdso32_enabled);
	*vdso32_enabled = old_vdso32_enabled;
}

module_init(vdso_disable_init);
module_exit(vdso_disable_exit);
